diff -rN -u old-darcsweb/darcsweb.cgi new-darcsweb/darcsweb.cgi
--- old-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
+++ new-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
@@ -365,844 +411,938 @@
   <a href="%(myreponame)s;a=summary">%(reponame)s</a> /
   %(action)s
 </div>
-	""" % {
-		'reponame': config.reponame,
-		'css': config.cssfile,
-		'url': config.myurl + '/' + config.myreponame,
-		'fav': config.darcsfav,
-		'logo': config.darcslogo,
-		'myname': config.myname,
-		'myreponame': config.myreponame,
-		'action': action
-	}
-
-
-def print_footer(put_rss = 1):
-	print """
+	"""
+        % {
+            "reponame": config.reponame,
+            "css": config.cssfile,
+            "url": config.myurl + "/" + config.myreponame,
+            "fav": config.darcsfav,
+            "logo": config.darcslogo,
+            "myname": config.myname,
+            "myreponame": config.myreponame,
+            "action": action,
+        }
+    )
+
+
+def print_footer(put_rss=1):
+    print(
+        """
 <div class="page_footer">
 <div class="page_footer_text">%s</div>
-	""" % config.footer
-	if put_rss:
-		print '<a class="rss_logo" href="%s;a=rss">RSS</a>' % \
-				(config.myurl + '/' + config.myreponame)
-	print "</div>\n</body>\n</html>"
+	"""
+        % config.footer
+    )
+    if put_rss:
+        print(
+            '<a class="rss_logo" href="%s;a=rss">RSS</a>'
+            % (config.myurl + "/" + config.myreponame)
+        )
+    print("</div>\n</body>\n</html>")
 
 
-def print_navbar(h = "", f = ""):
-	print """
+def print_navbar(h="", f=""):
+    print(
+        """
 <div class="page_nav">
 <a href="%(myreponame)s;a=summary">summary</a>
 | <a href="%(myreponame)s;a=shortlog">shortlog</a>
 | <a href="%(myreponame)s;a=log">log</a>
 | <a href="%(myreponame)s;a=tree">tree</a>
-	""" % { "myreponame": config.myreponame }
+	"""
+        % {"myreponame": config.myreponame}
+    )
 
-	if h:
-		print """
+    if h:
+        print(
+            """
 | <a href="%(myreponame)s;a=commit;h=%(hash)s">commit</a>
 | <a href="%(myreponame)s;a=commitdiff;h=%(hash)s">commitdiff</a>
 | <a href="%(myreponame)s;a=headdiff;h=%(hash)s">headdiff</a>
-		""" % { "myreponame": config.myreponame, 'hash': h }
+		"""
+            % {"myreponame": config.myreponame, "hash": h}
+        )
 
-	realf = realpath(f)
-	f = urllib.quote(f)
+    realf = realpath(f)
+    f = urlescape(f)
 
-	if f and h:
-		print """
+    if f and h:
+        print(
+            """
 | <a href="%(myreponame)s;a=annotate_shade;f=%(fname)s;h=%(hash)s">annotate</a>
-		""" % {
-			'myreponame': config.myreponame,
-			'hash': h,
-			'fname': f
-		}
-	elif f:
-		print """
+		"""
+            % {"myreponame": config.myreponame, "hash": h, "fname": f}
+        )
+    elif f:
+        print(
+            """
 | <a href="%(myreponame)s;a=annotate_shade;f=%(fname)s">annotate</a>
-		""" % { "myreponame": config.myreponame, 'fname': f }
+		"""
+            % {"myreponame": config.myreponame, "fname": f}
+        )
 
-	if f and os.path.isfile(realf):
-		print """
+    if f and os.path.isfile(realf):
+        print(
+            """
 | <a href="%(myreponame)s;a=headblob;f=%(fname)s">headblob</a>
-		""" % { "myreponame": config.myreponame, 'fname': f }
+		"""
+            % {"myreponame": config.myreponame, "fname": f}
+        )
 
-	if f and os.path.isdir(realf):
-		print """
+    if f and os.path.isdir(realf):
+        print(
+            """
 | <a href="%(myreponame)s;a=tree;f=%(fname)s">headtree</a>
-		"""  % { "myreponame": config.myreponame, 'fname': f }
+		"""
+            % {"myreponame": config.myreponame, "fname": f}
+        )
 
-	if h and f and (os.path.isfile(realf) or os.path.isdir(realf)):
-		print """
+    if h and f and (os.path.isfile(realf) or os.path.isdir(realf)):
+        print(
+            """
 | <a href="%(myreponame)s;a=headfilediff;h=%(hash)s;f=%(fname)s">headfilediff</a>
-		""" % { "myreponame": config.myreponame, 'hash': h, 'fname': f }
+		"""
+            % {"myreponame": config.myreponame, "hash": h, "fname": f}
+        )
 
-	if f:
-		print """
+    if f:
+        print(
+            """
 | <a class="link" href="%(myreponame)s;a=filehistory;f=%(fname)s">filehistory</a>
-		""" % { "myreponame": config.myreponame, 'fname': f }
-
-	print "<br/>"
+		"""
+            % {"myreponame": config.myreponame, "fname": f}
+        )
 
-	efaction = action
-	if '_' in action:
-		# action is composed as "format_action", like
-		# "darcs_commitdiff"; so we get the "effective action" to
-		# decide if we need to present the "alternative formats" menu
-		pos = action.find('_')
-		fmt = action[:pos]
-		efaction = action[pos + 1:]
-	if efaction in ("commit", "commitdiff", "filediff", "headdiff",
-			"headfilediff"):
-
-		# in order to show the small bar in the commit page too, we
-		# accept it here and change efaction to commitdiff, because
-		# that's what we're really intrested in
-		if efaction == "commit":
-			efaction = "commitdiff"
-
-		params = 'h=%s;' % h
-		if f:
-			params += 'f=%s;' % f
+    print("<br/>")
 
-		# normal (unified)
-		print """
+    efaction = action
+    if "_" in action:
+        # action is composed as "format_action", like
+        # "darcs_commitdiff"; so we get the "effective action" to
+        # decide if we need to present the "alternative formats" menu
+        pos = action.find("_")
+        fmt = action[:pos]
+        efaction = action[pos + 1 :]
+    if efaction in (
+        "commit",
+        "commitdiff",
+        "filediff",
+        "headdiff",
+        "headfilediff",
+    ):
+
+        # in order to show the small bar in the commit page too, we
+        # accept it here and change efaction to commitdiff, because
+        # that's what we're really intrested in
+        if efaction == "commit":
+            efaction = "commitdiff"
+
+        params = "h=%s;" % h
+        if f:
+            params += "f=%s;" % f
+
+        # normal (unified)
+        print(
+            """
 <a class="link" href="%(myreponame)s;a=%(act)s;%(params)s">unified</a>
-		""" % { "myreponame": config.myreponame, "act": efaction,
-			"params": params }
-
-		# plain
-		print """
+		"""
+            % {
+                "myreponame": config.myreponame,
+                "act": efaction,
+                "params": params,
+            }
+        )
+
+        # plain
+        print(
+            """
 | <a class="link" href="%(myreponame)s;a=plain_%(act)s;%(params)s">plain</a>
-		""" % { "myreponame": config.myreponame, "act": efaction,
-			"params": params }
-
-		# darcs, htmlized
-		print """
+		"""
+            % {
+                "myreponame": config.myreponame,
+                "act": efaction,
+                "params": params,
+            }
+        )
+
+        # darcs, htmlized
+        print(
+            """
 | <a class="link" href="%(myreponame)s;a=darcs_%(act)s;%(params)s">darcs</a>
-		""" % { "myreponame": config.myreponame, "act": efaction,
-			"params": params }
-
-		# darcs, raw, if available; and only for commitdiff
-		realf = filter_file(config.repodir + '/_darcs/patches/' + h)
-		if efaction == "commitdiff" and os.path.isfile(realf):
-			print """
-| <a class="link" href="%(myreponame)s;a=raw_%(act)s;%(params)s">raw</a>
-			""" % { "myreponame": config.myreponame,
-				"act": efaction, "params": params }
-
-	elif f and action == "headblob":
-		# show the only alternative format: plain
-		print """
+		"""
+            % {
+                "myreponame": config.myreponame,
+                "act": efaction,
+                "params": params,
+            }
+        )
+
+    elif f and action == "headblob":
+        # show the only alternative format: plain
+        print(
+            """
 <a class="link" href="%(myreponame)s;a=plainblob;f=%(fname)s">plain</a>
-		""" % { "myreponame": config.myreponame, "fname": f }
+		"""
+            % {"myreponame": config.myreponame, "fname": f}
+        )
 
-	elif f and h and action.startswith("annotate"):
-		# same for annotate
-		print """
+    elif f and h and action.startswith("annotate"):
+        # same for annotate
+        print(
+            """
 <a href="%(myreponame)s;a=annotate_normal;f=%(fname)s;h=%(hash)s">normal</a>
 | <a href="%(myreponame)s;a=annotate_plain;f=%(fname)s;h=%(hash)s">plain</a>
 | <a href="%(myreponame)s;a=annotate_shade;f=%(fname)s;h=%(hash)s">shade</a>
 | <a href="%(myreponame)s;a=annotate_zebra;f=%(fname)s;h=%(hash)s">zebra</a>
-		""" % {
-			"myreponame": config.myreponame,
-			"fname": f,
-			"hash": h
-		}
+		"""
+            % {"myreponame": config.myreponame, "fname": f, "hash": h}
+        )
+
+    print("<br/>")
+    print("</div>")
+
+
+def print_readme():
+    if not config.readme:
+        return
+    try:
+        file = open(config.repodir + "/" + config.readme, mode="r")
+    except:
+        return
+    readme_markdown = file.read()
+    file.close()
+
+    try:
+        import markdown
+
+        readme_html = markdown.markdown(readme_markdown)
+    except:
+        return
+
+    print(
+        """
+<br/>
+<br/>
+<div class="title">%s</div>
+<div class="page_readme">"""
+        % config.readme
+    )
+
+    print(readme_html)
+    print("</div>")
 
-	print '<br/>'
-	print '</div>'
 
 def print_plain_header():
-	print "Content-type: text/plain; charset=utf-8\n"
+    print("Content-type: text/plain; charset=utf-8\n")
+
+
+def print_binary_header(fname=None):
+    import mimetypes
+
+    if fname:
+        (mime, enc) = mimetypes.guess_type(fname)
+    else:
+        mime = None
+    if mime:
+        print("Content-type: %s" % mime)
+    else:
+        print("Content-type: application/octet-stream")
+    if fname:
+        print("Content-Disposition:attachment;filename=%s" % fname)
+    print
 
-def print_binary_header(fname = None):
-	import mimetypes
-	if fname :
-		(mime, enc) = mimetypes.guess_type(fname)
-	else :
-		mime = None
-	if mime :
-		print "Content-type: %s" % mime
-	else :
-		print "Content-type: application/octet-stream"
-	if fname:
-		print "Content-Disposition:attachment;filename=%s" % fname
-	print
 
 def gen_authorlink(author, shortauthor=None):
-	if not config.author_links:
-		if shortauthor:
-			return shortauthor
-		else:
-			return author
-	if not shortauthor:
-		shortauthor = author
-	return '<a href="' + config.author_links % { 'author': author } + '">%s</a>' % shortauthor
+    if not config.author_links:
+        if shortauthor:
+            return shortauthor
+        else:
+            return author
+    if not shortauthor:
+        shortauthor = author
+    return (
+        '<a href="'
+        + config.author_links % {"author": author}
+        + '">%s</a>' % shortauthor
+    )
+
 
 #
 # basic caching
 #
 
+
 class Cache:
-	def __init__(self, basedir, url):
-		try:
-			import hashlib
-			sha = hashlib.sha1
-		except ImportError:
-			from sha import sha
-
-		self.basedir = basedir
-		self.url = url
-		self.fname = sha(repr(url)).hexdigest()
-		self.file = None
-		self.mode = None
-		self.real_stdout = sys.stdout
-
-	def open(self):
-		"Returns 1 on hit, 0 on miss"
-		fname = self.basedir + '/' + self.fname
-
-		if not os.access(fname, os.R_OK):
-			# the file doesn't exist, direct miss
-			pid = str(os.getpid())
-			fname = self.basedir + '/.' + self.fname + '-' + pid
-			self.file = open(fname, 'w')
-			self.mode = 'w'
-			os.chmod(fname, stat.S_IRUSR | stat.S_IWUSR)
-
-			# step over stdout so when "print" tries to write
-			# output, we get it first
-			sys.stdout = self
-			return 0
-
-		inv = config.repodir + '/_darcs/patches'
-		cache_lastmod = os.stat(fname).st_mtime
-		repo_lastmod = os.stat(inv).st_mtime
-		dw_lastmod = os.stat(sys.argv[0]).st_mtime
-
-		if repo_lastmod > cache_lastmod or dw_lastmod > cache_lastmod:
-			# the entry is too old, remove it and return a miss
-			os.unlink(fname)
-
-			pid = str(os.getpid())
-			fname = self.basedir + '/.' + self.fname + '-' + pid
-			self.file = open(fname, 'w')
-			self.mode = 'w'
-			sys.stdout = self
-			return 0
-
-		# the entry is still valid, hit!
-		self.file = open(fname, 'r')
-		self.mode = 'r'
-		return 1
-
-
-	def dump(self):
-		for l in self.file:
-			self.real_stdout.write(l)
-
-	def write(self, s):
-		# this gets called from print, because we replaced stdout with
-		# ourselves
-		self.file.write(s)
-		self.real_stdout.write(s)
-
-	def close(self):
-		if self.file:
-			self.file.close()
-		sys.stdout = self.real_stdout
-		if self.mode == 'w':
-			pid = str(os.getpid())
-			fname1 = self.basedir + '/.' + self.fname + '-' + pid
-			fname2 = self.basedir + '/' + self.fname
-			os.rename(fname1, fname2)
-			self.mode = 'c'
-
-	def cancel(self):
-		"Like close() but don't save the entry."
-		if self.file:
-			self.file.close()
-		sys.stdout = self.real_stdout
-		if self.mode == 'w':
-			pid = str(os.getpid())
-			fname = self.basedir + '/.' + self.fname + '-' + pid
-			os.unlink(fname)
-			self.mode = 'c'
+    def __init__(self, basedir, url):
+        import hashlib
+
+        self.basedir = basedir
+        self.url = url
+        self.fname = hashlib.sha1(repr(url)).hexdigest()
+        self.file = None
+        self.mode = None
+        self.real_stdout = sys.stdout
+
+    def open(self):
+        "Returns 1 on hit, 0 on miss"
+        fname = self.basedir + "/" + self.fname
+
+        if not os.access(fname, os.R_OK):
+            # the file doesn't exist, direct miss
+            pid = str(os.getpid())
+            fname = self.basedir + "/." + self.fname + "-" + pid
+            self.file = open(fname, "w")
+            self.mode = "w"
+            os.chmod(fname, stat.S_IRUSR | stat.S_IWUSR)
+
+            # step over stdout so when "print" tries to write
+            # output, we get it first
+            sys.stdout = self
+            return 0
+
+        inv = config.repodir + "/_darcs/patches"
+        cache_lastmod = os.stat(fname).st_mtime
+        repo_lastmod = os.stat(inv).st_mtime
+        dw_lastmod = os.stat(sys.argv[0]).st_mtime
+
+        if repo_lastmod > cache_lastmod or dw_lastmod > cache_lastmod:
+            # the entry is too old, remove it and return a miss
+            os.unlink(fname)
+
+            pid = str(os.getpid())
+            fname = self.basedir + "/." + self.fname + "-" + pid
+            self.file = open(fname, "w")
+            self.mode = "w"
+            sys.stdout = self
+            return 0
+
+        # the entry is still valid, hit!
+        self.file = open(fname, "r")
+        self.mode = "r"
+        return 1
+
+    def dump(self):
+        for l in self.file:
+            self.real_stdout.write(l)
+
+    def write(self, s):
+        # this gets called from print, because we replaced stdout with
+        # ourselves
+        self.file.write(s)
+        self.real_stdout.write(s)
+
+    def close(self):
+        if self.file:
+            self.file.close()
+        sys.stdout = self.real_stdout
+        if self.mode == "w":
+            pid = str(os.getpid())
+            fname1 = self.basedir + "/." + self.fname + "-" + pid
+            fname2 = self.basedir + "/" + self.fname
+            os.rename(fname1, fname2)
+            self.mode = "c"
+
+    def cancel(self):
+        "Like close() but don't save the entry."
+        if self.file:
+            self.file.close()
+        sys.stdout = self.real_stdout
+        if self.mode == "w":
+            pid = str(os.getpid())
+            fname = self.basedir + "/." + self.fname + "-" + pid
+            os.unlink(fname)
+            self.mode = "c"
 
 
 #
 # darcs repo manipulation
 #
 
+
 def repo_get_owner():
-	try:
-		fd = open(config.repodir + '/_darcs/prefs/author')
-	except IOError:
-		return None
-
-	author = None
-	for line in fd:
-		line = line.strip()
-		if not line.startswith("#"):
-			author = line
-			break
-	return author
+    try:
+        fd = open(config.repodir + "/_darcs/prefs/author")
+    except IOError:
+        return None
+
+    author = None
+    for line in fd:
+        line = line.strip()
+        if not line.startswith("#"):
+            author = line
+            break
+    return author
+
 
 def run_subprocess(params):
-	"""Wrapper to subprocess.Popen(), which we use to provide backwards
-	compatibility when it's not available. Returns stdout."""
-	try:
-		import subprocess
-		p = subprocess.Popen(params,
-				stdin = None,
-				stdout = subprocess.PIPE,
-				stderr = subprocess.STDOUT)
-		return p.stdout
-	except ImportError:
-		cmd = ' '.join(params)
-		inf, outf = os.popen4(cmd, 't')
-		return outf
+    """Wrapper to subprocess.Popen(), which we use to provide backwards
+    compatibility when it's not available. Returns stdout."""
+    import subprocess
+
+    p = subprocess.Popen(
+        params,
+        stdin=None,
+        stdout=subprocess.PIPE,
+        stderr=subprocess.STDOUT,
+    )
+    return io.TextIOWrapper(
+        p.stdout, encoding="utf8", errors="backslashreplace"
+    )
+
 
 def run_darcs(*params):
-	"""Runs darcs on the repodir with the given params, return a file
-	object with its output."""
-	os.chdir(config.repodir)
-	try:
-		original_8bit_setting = os.environ['DARCS_DONT_ESCAPE_8BIT']
-	except KeyError:
-		original_8bit_setting = None
-	os.environ['DARCS_DONT_ESCAPE_8BIT'] = '1'
-
-	# Recent darcs versions require the PATH environment variable to be
-	# present in order to find "diff"; if it's not set we give it a
-	# reasonably basic one which would work in most cases, but ideally it
-	# should be properly set by the web server.
-	if 'PATH' not in os.environ:
-		os.environ['PATH'] = ':'.join([config.darcspath, '/bin',
-						'/usr/bin'])
-
-	outf = run_subprocess([config.darcspath + "darcs"] + list(params))
-
-	darcs_runs.append(params)
-	if original_8bit_setting == None:
-		del(os.environ['DARCS_DONT_ESCAPE_8BIT'])
-	else:
-		os.environ['DARCS_DONT_ESCAPE_8BIT'] = original_8bit_setting
-	return outf
+    """Runs darcs on the repodir with the given params, return a file
+    object with its output."""
+    os.chdir(config.repodir)
+    try:
+        original_8bit_setting = os.environ["DARCS_DONT_ESCAPE_8BIT"]
+    except KeyError:
+        original_8bit_setting = None
+    os.environ["DARCS_DONT_ESCAPE_8BIT"] = "1"
+
+    # Recent darcs versions require the PATH environment variable to be
+    # present in order to find "diff"; if it's not set we give it a
+    # reasonably basic one which would work in most cases, but ideally it
+    # should be properly set by the web server.
+    if "PATH" not in os.environ:
+        os.environ["PATH"] = ":".join([config.darcspath, "/bin", "/usr/bin"])
+
+    outf = run_subprocess([config.darcspath + "darcs"] + list(params))
+
+    darcs_runs.append(params)
+    if original_8bit_setting == None:
+        del os.environ["DARCS_DONT_ESCAPE_8BIT"]
+    else:
+        os.environ["DARCS_DONT_ESCAPE_8BIT"] = original_8bit_setting
+    return outf
 
 
 class Patch:
-	"Represents a single patch/record"
-	def __init__(self):
-		self.hash = ''
-		self.author = ''
-		self.shortauthor = ''
-		self.date = 0
-		self.local_date = 0
-		self.name = ''
-		self.comment = ''
-		self.inverted = False;
-		self.adds = []
-		self.removes = []
-		self.modifies = {}
-		self.diradds = []
-		self.dirremoves = []
-		self.replaces = {}
-		self.moves = {}
-
-	def tostr(self):
-		s = "%s\n\tAuthor: %s\n\tDate: %s\n\tHash: %s\n" % \
-			(self.name, self.author, self.date, self.hash)
-		return s
-
-	def getdiff(self):
-		"""Returns a list of lines from the diff -u corresponding with
-		the patch."""
-		f = run_darcs('diff', '--quiet', '-u',
-				'--match', 'hash %s' % self.hash)
-		return f.readlines()
-
-	def matches(self, s):
-		"Defines if the patch matches a given string"
-		if s.lower() in self.comment.lower():
-			return self.comment
-		elif s.lower() in self.name.lower():
-			return self.name
-		elif s.lower() in self.author.lower():
-			return self.author
-		elif s == self.hash:
-			return self.hash
-
-		s = s.lower()
-		for l in (self.adds, self.removes, self.modifies,
-				self.diradds, self.dirremoves,
-				self.replaces.keys(), self.moves.keys(),
-				self.moves.keys() ):
-			for i in l:
-				if s in i.lower():
-					return i
-		return ''
+    "Represents a single patch/record"
+
+    def __init__(self):
+        self.hash = ""
+        self.author = ""
+        self.shortauthor = ""
+        self.date = 0
+        self.local_date = 0
+        self.name = ""
+        self.comment = ""
+        self.inverted = False
+        self.adds = []
+        self.removes = []
+        self.modifies = {}
+        self.diradds = []
+        self.dirremoves = []
+        self.replaces = {}
+        self.moves = {}
+
+    def tostr(self):
+        s = "%s\n\tAuthor: %s\n\tDate: %s\n\tHash: %s\n" % (
+            self.name,
+            self.author,
+            self.date,
+            self.hash,
+        )
+        return s
+
+    def getdiff(self):
+        """Returns a list of lines from the diff -u corresponding with
+        the patch."""
+        f = run_darcs(
+            "diff", "--quiet", "-u", "--match", "hash %s" % self.hash
+        )
+        return f.readlines()
+
+    def matches(self, s):
+        "Defines if the patch matches a given string"
+        if s.lower() in self.comment.lower():
+            return self.comment
+        elif s.lower() in self.name.lower():
+            return self.name
+        elif s.lower() in self.author.lower():
+            return self.author
+        elif s == self.hash:
+            return self.hash
+
+        s = s.lower()
+        for l in (
+            self.adds,
+            self.removes,
+            self.modifies,
+            self.diradds,
+            self.dirremoves,
+            self.replaces.keys(),
+            self.moves.keys(),
+            self.moves.keys(),
+        ):
+            for i in l:
+                if s in i.lower():
+                    return i
+        return ""
+
 
 class XmlInputWrapper:
-	def __init__(self, fd):
-		self.fd = fd
-		self._header_done = False
-		self._changelog_done = False
-		self._read = self.read
-
-	def read(self, *args, **kwargs):
-		if not self._header_done:
-			self._header_done = True
-			return '<?xml version="1.0" encoding="utf-8"?>\n'
-
-		if not self._changelog_done:
-			# Read lines until we see "<changelog>". Sometimes the output has
-			# human-readable lines before the XML begins, this is our way to
-			# work around that.
-			self._changelog_done = True
-			while True:
-				l = self.fd.readline()
-				if not l:
-					return l
-				if "<changelog>" in l:
-					return l
-
-		s = self.fd.read(*args, **kwargs)
-		if not s:
-			return s
-		return fixu8(s)
+    def __init__(self, fd):
+        self.fd = fd
+        self._header_done = False
+        self._changelog_done = False
+        self._read = self.read
+
+    def read(self, *args, **kwargs):
+        if not self._header_done:
+            self._header_done = True
+            return '<?xml version="1.0" encoding="utf-8"?>\n'
+
+        if not self._changelog_done:
+            # Read lines until we see "<changelog>". Sometimes the output has
+            # human-readable lines before the XML begins, this is our way to
+            # work around that.
+            self._changelog_done = True
+            while True:
+                l = self.fd.readline()
+                if not l:
+                    return l
+                if "<changelog>" in l:
+                    return l
 
-	def close(self, *args, **kwargs):
-		return self.fd.close(*args, **kwargs)
+        return self.fd.read(*args, **kwargs)
+
+    def close(self, *args, **kwargs):
+        return self.fd.close(*args, **kwargs)
 
 
 # patch parsing, we get them through "darcs changes --xml-output"
 class BuildPatchList(xml.sax.handler.ContentHandler):
-	def __init__(self):
-		self.db = {}
-		self.list = []
-		self.cur_hash = ''
-		self.cur_elem = None
-		self.cur_val = ''
-		self.cur_file = ''
-
-		# Ignore the following elements (and sub-elements):
-		# - created_as: When you ask for changes to a given file, the xml
-		#   output begins with the patch that creates it is enclosed in a
-		#   "created_as" tag; then, later, it gets shown again in its usual
-		#   place. Ignore it to avoid double-counting.
-		# - explicit_dependencies: they appear within tag patches as a way of
-		#   indicating dependencies, but we don't really use them, and
-		#   counting them in could be confusing.
-		self.ignored_elems = ['created_as', 'explicit_dependencies']
-
-	def startElement(self, name, attrs):
-		# Skip ignored elements and sub-elements.
-		for ignore_elem in self.ignored_elems:
-			if name == ignore_elem:
-				self.cur_elem = ignore_elem
-				return
-			if self.cur_elem == ignore_elem:
-				return
-
-		# now parse the tags normally
-		if name == 'patch':
-			p = Patch()
-			p.hash = fixu8(attrs.get('hash'))
-
-			au = attrs.get('author', None)
-			p.author = fixu8(escape(au))
-			if au.find('<') != -1:
-				au = au[:au.find('<')].strip()
-			p.shortauthor = fixu8(escape(au))
-
-			td = parse_darcs_time(attrs.get('date', None))
-			p.date = time.mktime(td)
-			p.date_str = time.strftime("%a, %d %b %Y %H:%M:%S", td)
-
-			td = time.strptime(attrs.get('local_date', None),
-					"%a %b %d %H:%M:%S %Z %Y")
-			p.local_date = time.mktime(td)
-			p.local_date_str = \
-				time.strftime("%a, %d %b %Y %H:%M:%S", td)
-
-			inverted = attrs.get('inverted', None)
-			if inverted and inverted == 'True':
-				p.inverted = True
-
-			self.db[p.hash] = p
-			self.current = p.hash
-			self.list.append(p.hash)
-		elif name == 'name':
-			self.db[self.current].name = ''
-			self.cur_elem = 'name'
-		elif name == 'comment':
-			self.db[self.current].comment = ''
-			self.cur_elem = 'comment'
-		elif name == 'add_file':
-			self.cur_elem = 'add_file'
-		elif name == 'remove_file':
-			self.cur_elem = 'remove_file'
-		elif name == 'add_directory':
-			self.cur_elem = 'add_directory'
-		elif name == 'remove_directory':
-			self.cur_elem = 'remove_dir'
-		elif name == 'modify_file':
-			self.cur_elem = 'modify_file'
-		elif name == 'removed_lines':
-			if self.cur_val:
-				self.cur_file = fixu8(self.cur_val.strip())
-			cf = self.cur_file
-			p = self.db[self.current]
-			# the current value holds the file name at this point
-			if not p.modifies.has_key(cf):
-				p.modifies[cf] = { '+': 0, '-': 0 }
-			p.modifies[cf]['-'] = int(attrs.get('num', None))
-		elif name == 'added_lines':
-			if self.cur_val:
-				self.cur_file = fixu8(self.cur_val.strip())
-			cf = self.cur_file
-			p = self.db[self.current]
-			if not p.modifies.has_key(cf):
-				p.modifies[cf] = { '+': 0, '-': 0 }
-			p.modifies[cf]['+'] = int(attrs.get('num', None))
-		elif name == 'move':
-			src = fixu8(attrs.get('from', None))
-			dst = fixu8(attrs.get('to', None))
-			p = self.db[self.current]
-			p.moves[src] = dst
-		elif name == 'replaced_tokens':
-			if self.cur_val:
-				self.cur_file = fixu8(self.cur_val.strip())
-			cf = self.cur_file
-			p = self.db[self.current]
-			if not p.replaces.has_key(cf):
-				p.replaces[cf] = 0
-			p.replaces[cf] = int(attrs.get('num', None))
-		else:
-			self.cur_elem = None
-
-	def characters(self, s):
-		if not self.cur_elem:
-			return
-		self.cur_val += s
-
-	def endElement(self, name):
-		# Skip ignored elements and sub-elements.
-		for ignore_elem in self.ignored_elems:
-			if name == ignore_elem:
-				self.cur_elem = None
-				self.cur_val = ''
-				return
-			if self.cur_elem == ignore_elem:
-				return
-
-		if name == 'replaced_tokens':
-			return
-
-		if name == 'name':
-			p = self.db[self.current]
-			p.name = fixu8(self.cur_val)
-			if p.inverted:
-				p.name = 'UNDO: ' + p.name
-		elif name == 'comment':
-			self.db[self.current].comment = fixu8(strip_ignore_this(self.cur_val))
-		elif name == 'add_file':
-			scv = fixu8(self.cur_val.strip())
-			self.db[self.current].adds.append(scv)
-		elif name == 'remove_file':
-			scv = fixu8(self.cur_val.strip())
-			self.db[self.current].removes.append(scv)
-		elif name == 'add_directory':
-			scv = fixu8(self.cur_val.strip())
-			self.db[self.current].diradds.append(scv)
-		elif name == 'remove_directory':
-			scv = fixu8(self.cur_val.strip())
-			self.db[self.current].dirremoves.append(scv)
-
-		elif name == 'modify_file':
-			if not self.cur_file:
-				# binary modification appear without a line
-				# change summary, so we add it manually here
-				f = fixu8(self.cur_val.strip())
-				p = self.db[self.current]
-				p.modifies[f] = { '+': 0, '-': 0, 'b': 1 }
-			self.cur_file = ''
-
-		self.cur_elem = None
-		self.cur_val = ''
-
-	def get_list(self):
-		plist = []
-		for h in self.list:
-			plist.append(self.db[h])
-		return plist
+    def __init__(self):
+        self.db = {}
+        self.list = []
+        self.cur_hash = ""
+        self.cur_elem = None
+        self.cur_val = ""
+        self.cur_file = ""
+
+        # Ignore the following elements (and sub-elements):
+        # - created_as: When you ask for changes to a given file, the xml
+        #   output begins with the patch that creates it is enclosed in a
+        #   "created_as" tag; then, later, it gets shown again in its usual
+        #   place. Ignore it to avoid double-counting.
+        # - explicit_dependencies: they appear within tag patches as a way of
+        #   indicating dependencies, but we don't really use them, and
+        #   counting them in could be confusing.
+        self.ignored_elems = ["created_as", "explicit_dependencies"]
+
+    def startElement(self, name, attrs):
+        # Skip ignored elements and sub-elements.
+        for ignore_elem in self.ignored_elems:
+            if name == ignore_elem:
+                self.cur_elem = ignore_elem
+                return
+            if self.cur_elem == ignore_elem:
+                return
+
+        # now parse the tags normally
+        if name == "patch":
+            p = Patch()
+            p.hash = attrs.get("hash")
+
+            au = attrs.get("author", None)
+            p.author = xmlescape(au)
+            if au.find("<") != -1:
+                au = au[: au.find("<")].strip()
+            p.shortauthor = xmlescape(au)
+
+            td = parse_darcs_time(attrs.get("date", None))
+            p.date = time.mktime(td)
+            p.date_str = time.strftime("%a, %d %b %Y %H:%M:%S", td)
+
+            td = time.strptime(
+                attrs.get("local_date", None), "%a %b %d %H:%M:%S %Z %Y"
+            )
+            p.local_date = time.mktime(td)
+            p.local_date_str = time.strftime("%a, %d %b %Y %H:%M:%S", td)
+
+            inverted = attrs.get("inverted", None)
+            if inverted and inverted == "True":
+                p.inverted = True
+
+            self.db[p.hash] = p
+            self.current = p.hash
+            self.list.append(p.hash)
+        elif name == "name":
+            self.db[self.current].name = ""
+            self.cur_elem = "name"
+        elif name == "comment":
+            self.db[self.current].comment = ""
+            self.cur_elem = "comment"
+        elif name == "add_file":
+            self.cur_elem = "add_file"
+        elif name == "remove_file":
+            self.cur_elem = "remove_file"
+        elif name == "add_directory":
+            self.cur_elem = "add_directory"
+        elif name == "remove_directory":
+            self.cur_elem = "remove_dir"
+        elif name == "modify_file":
+            self.cur_elem = "modify_file"
+        elif name == "removed_lines":
+            if self.cur_val:
+                self.cur_file = self.cur_val.strip()
+            cf = self.cur_file
+            p = self.db[self.current]
+            # the current value holds the file name at this point
+            if not cf in p.modifies:
+                p.modifies[cf] = {"+": 0, "-": 0}
+            p.modifies[cf]["-"] = int(attrs.get("num", None))
+        elif name == "added_lines":
+            if self.cur_val:
+                self.cur_file = self.cur_val.strip()
+            cf = self.cur_file
+            p = self.db[self.current]
+            if not cf in p.modifies:
+                p.modifies[cf] = {"+": 0, "-": 0}
+            p.modifies[cf]["+"] = int(attrs.get("num", None))
+        elif name == "move":
+            src = attrs.get("from", None)
+            dst = attrs.get("to", None)
+            p = self.db[self.current]
+            p.moves[src] = dst
+        elif name == "replaced_tokens":
+            if self.cur_val:
+                self.cur_file = self.cur_val.strip()
+            cf = self.cur_file
+            p = self.db[self.current]
+            if not cf in p.replaces:
+                p.replaces[cf] = 0
+            p.replaces[cf] = int(attrs.get("num", None))
+        else:
+            self.cur_elem = None
+
+    def characters(self, s):
+        if not self.cur_elem:
+            return
+        self.cur_val += s
+
+    def endElement(self, name):
+        # Skip ignored elements and sub-elements.
+        for ignore_elem in self.ignored_elems:
+            if name == ignore_elem:
+                self.cur_elem = None
+                self.cur_val = ""
+                return
+            if self.cur_elem == ignore_elem:
+                return
+
+        if name == "replaced_tokens":
+            return
+
+        if name == "name":
+            p = self.db[self.current]
+            p.name = self.cur_val
+            if p.inverted:
+                p.name = "UNDO: " + p.name
+        elif name == "comment":
+            self.db[self.current].comment = strip_ignore_this(self.cur_val)
+        elif name == "add_file":
+            scv = self.cur_val.strip()
+            self.db[self.current].adds.append(scv)
+        elif name == "remove_file":
+            scv = self.cur_val.strip()
+            self.db[self.current].removes.append(scv)
+        elif name == "add_directory":
+            scv = self.cur_val.strip()
+            self.db[self.current].diradds.append(scv)
+        elif name == "remove_directory":
+            scv = self.cur_val.strip()
+            self.db[self.current].dirremoves.append(scv)
+
+        elif name == "modify_file":
+            if not self.cur_file:
+                # binary modification appear without a line
+                # change summary, so we add it manually here
+                f = self.cur_val.strip()
+                p = self.db[self.current]
+                p.modifies[f] = {"+": 0, "-": 0, "b": 1}
+            self.cur_file = ""
+
+        self.cur_elem = None
+        self.cur_val = ""
+
+    def get_list(self):
+        plist = []
+        for h in self.list:
+            plist.append(self.db[h])
+        return plist
+
+    def get_db(self):
+        return self.db
 
-	def get_db(self):
-		return self.db
+    def get_list_db(self):
+        return (self.list, self.db)
 
-	def get_list_db(self):
-		return (self.list, self.db)
 
 def get_changes_handler(*params):
-	"Returns a handler for the changes output, run with the given params"
-	parser = xml.sax.make_parser()
-	handler = BuildPatchList()
-	parser.setContentHandler(handler)
-
-	# get the xml output and parse it
-	xmlf = run_darcs("changes", "--xml-output", *params)
-	parser.parse(XmlInputWrapper(xmlf))
-	xmlf.close()
-
-	return handler
-
-def get_last_patches(last = 15, topi = 0, fname = None):
-	"""Gets the last N patches from the repo, returns a patch list. If
-	"topi" is specified, then it will return the N patches that preceeded
-	the patch number topi in the list. It sounds messy but it's quite
-	simple. You can optionally pass a filename and only changes that
-	affect it will be returned. FIXME: there's probably a more efficient
-	way of doing this."""
-
-	# darcs calculate last first, and then filters the filename,
-	# so it's not so simple to combine them; that's why we do so much
-	# special casing here
-	toget = last + topi
-
-	if fname:
-		if fname[0] == '/': fname = fname[1:]
-		params = ('-s', fname)
-	else:
-		params = ('-s', '--last=%d' % toget)
+    "Returns a handler for the changes output, run with the given params"
+    parser = xml.sax.make_parser()
+    handler = BuildPatchList()
+    parser.setContentHandler(handler)
+
+    # get the xml output and parse it
+    xmlf = run_darcs("changes", "--xml-output", *params)
+    parser.parse(XmlInputWrapper(xmlf))
+    xmlf.close()
+
+    return handler
+
+
+def get_last_patches(last=15, topi=0, fname=None):
+    """Gets the last N patches from the repo, returns a patch list. If
+    "topi" is specified, then it will return the N patches that preceeded
+    the patch number topi in the list. It sounds messy but it's quite
+    simple. You can optionally pass a filename and only changes that
+    affect it will be returned. FIXME: there's probably a more efficient
+    way of doing this."""
+
+    # darcs calculate last first, and then filters the filename,
+    # so it's not so simple to combine them; that's why we do so much
+    # special casing here
+    toget = last + topi
+
+    if fname:
+        if fname[0] == "/":
+            fname = fname[1:]
+        params = ("-s", fname)
+    else:
+        params = ("-s", "--last=%d" % toget)
 
-	handler = get_changes_handler(*params)
+    handler = get_changes_handler(*params)
+
+    # return the list of all the patch objects
+    return handler.get_list()[topi:toget]
 
-	# return the list of all the patch objects
-	return handler.get_list()[topi:toget]
 
 def get_patch(hash):
-	handler = get_changes_handler('-s', '--match', 'hash %s' % hash)
-	patch = handler.db[handler.list[0]]
-	return patch
+    handler = get_changes_handler("-s", "--match", "hash %s" % hash)
+    patch = handler.db[handler.list[0]]
+    return patch
+
 
 def get_diff(hash):
-	return run_darcs('diff', '--quiet', '-u',
-			'--match', 'hash %s' % hash)
+    return run_darcs("diff", "--quiet", "-u", "--match", "hash %s" % hash)
+
 
 def get_file_diff(hash, fname):
-	return run_darcs('diff', '--quiet', '-u',
-			'--match', 'hash %s' % hash, fname)
+    return run_darcs(
+        "diff", "--quiet", "-u", "--match", "hash %s" % hash, fname
+    )
+
 
 def get_file_headdiff(hash, fname):
-	return run_darcs('diff', '--quiet', '-u',
-			'--from-match', 'hash %s' % hash, fname)
+    return run_darcs(
+        "diff", "--quiet", "-u", "--from-match", "hash %s" % hash, fname
+    )
+
 
 def get_patch_headdiff(hash):
-	return run_darcs('diff', '--quiet', '-u',
-			'--from-match', 'hash %s' % hash)
+    return run_darcs("diff", "--quiet", "-u", "--from-match", "hash %s" % hash)
+
+
+def get_darcs_diff(hash, fname=None):
+    params = ["changes", "-v", "--matches", "hash %s" % hash]
+    if fname:
+        params.append(fname)
+    return run_darcs(*params)
 
-def get_raw_diff(hash):
-	import gzip
-	realf = filter_file(config.repodir + '/_darcs/patches/' + hash)
-	if not os.path.isfile(realf):
-		return None
-	file = open(realf, 'rb')
-	if file.read(2) == '\x1f\x8b':
-		# file begins with gzip magic
-		file.close()
-		dsrc = gzip.open(realf)
-	else:
-		file.seek(0)
-		dsrc = file
-	return dsrc
-
-def get_darcs_diff(hash, fname = None):
-	params = ['changes', '-v', '--matches', 'hash %s' % hash]
-	if fname:
-		params.append(fname)
-	return run_darcs(*params)
-
-def get_darcs_headdiff(hash, fname = None):
-	params = ['changes', '-v', '--from-match', 'hash %s' % hash]
-	if fname:
-		params.append(fname)
-	return run_darcs(*params)
+
+def get_darcs_headdiff(hash, fname=None):
+    params = ["changes", "-v", "--from-match", "hash %s" % hash]
+    if fname:
+        params.append(fname)
+    return run_darcs(*params)
 
 
 class Annotate:
-	def __init__(self):
-		self.fname = ""
-		self.lastchange_hash = ""
-		self.lastchange_author = ""
-		self.lastchange_name = ""
-		self.lastchange_date = None
-		self.lines = []
-
-		# hash -> date
-		self.patches = {}
-
-	class Line:
-		def __init__(self):
-			self.text = ""
-			self.phash = None
-			self.pauthor = None
-			self.pdate = None
+    def __init__(self):
+        self.fname = ""
+        self.lastchange_hash = ""
+        self.lastchange_author = ""
+        self.lastchange_name = ""
+        self.lastchange_date = None
+        self.lines = []
+
+        # hash -> date
+        self.patches = {}
+
+    class Line:
+        def __init__(self):
+            self.text = ""
+            self.phash = None
+            self.pauthor = None
+            self.pdate = None
 
-def parse_annotate(fname, src):
-	annotate = Annotate()
-	annotate.fname = fname
 
-	# Hash -> Patch.
-	patches = {}
+def parse_annotate(fname, src):
+    annotate = Annotate()
+    annotate.fname = fname
 
-	for l in src:
-		if "|" not in l:
-			continue
-
-		line = Annotate.Line()
-		line.phash, line.text = l.split('|', 1)
-
-		# Darcs sometimes generates 00..00 hashes in the middle of the output
-		# due to a bug. Skip these and use the previous hash instead.
-		if int(line.phash, 16) == 0:
-			line.phash = prevhash
-		else:
-			prevhash = line.phash
-
-		if line.phash not in patches:
-			patch = get_patch(line.phash)
-			patches[line.phash] = patch
-
-		line.pauthor = patches[line.phash].author
-		line.pdate = time.localtime(patches[line.phash].date)
-		annotate.patches[line.phash] = patch.date
-		annotate.lines.append(line)
-
-	if not annotate.lines:
-		return
-
-	# Find the last patch, and update annotate information accordingly.
-	lastp = sorted(patches.values(), cmp=lambda a, b: cmp(a.date, b.date))[-1]
-	annotate.lastchange_hash = lastp.hash
-	annotate.lastchange_author = lastp.author
-	annotate.lastchange_name = lastp.name
-	annotate.lastchange_date = time.localtime(lastp.date)
-
-	return annotate
-
-def get_annotate(fname, hash = None):
-	if config.disable_annotate:
-		return None
-
-	params = ['annotate', '--machine-readable']
-	if hash:
-		params += ['--match', 'hash %s' % hash]
-
-	if fname.startswith('/'):
-		# darcs 2 doesn't like files starting with /, and darcs 1
-		# doesn't really care
-		fname = fname[1:]
-	params.append(fname)
+    # Hash -> Patch.
+    patches = {}
 
-	return parse_annotate(fname, run_darcs(*params))
+    prevhash = None
+    for l in src:
+        if "|" not in l:
+            continue
+
+        line = Annotate.Line()
+        line.phash, line.text = l.split("|", 1)
+
+        # Darcs sometimes generates 00..00 hashes in the middle of the output
+        # due to a bug. Skip these and use the previous hash instead.
+        if int(line.phash, 16) == 0:
+            line.phash = prevhash
+        else:
+            prevhash = line.phash
+        if line.phash:
+            if line.phash not in patches:
+                patch = get_patch(line.phash)
+                patches[line.phash] = patch
+
+            line.pauthor = patches[line.phash].author
+            line.pdate = time.localtime(patches[line.phash].date)
+            annotate.patches[line.phash] = patch.date
+            annotate.lines.append(line)
+
+    if not annotate.lines:
+        return
+
+    # Find the last patch, and update annotate information accordingly.
+    lastp = sorted(patches.values(), key=lambda a: a.date)[-1]
+    annotate.lastchange_hash = lastp.hash
+    annotate.lastchange_author = lastp.author
+    annotate.lastchange_name = lastp.name
+    annotate.lastchange_date = time.localtime(lastp.date)
+
+    return annotate
+
+
+def get_annotate(fname, hash=None):
+    if config.disable_annotate:
+        return None
+
+    params = ["annotate", "--machine-readable"]
+    if hash:
+        params += ["--match", "hash %s" % hash]
+
+    if fname.startswith("/"):
+        # darcs 2 doesn't like files starting with /, and darcs 1
+        # doesn't really care
+        fname = fname[1:]
+    params.append(fname)
 
+    return parse_annotate(fname, run_darcs(*params))
 
 
 #
 # specific html functions
 #
 
-def print_diff(dsrc):
-	for l in dsrc:
-		l = fixu8(l)
 
-		# remove the trailing newline
-		if len(l) > 1:
-			l = l[:-1]
-
-		if l.startswith('diff'):
-			# file lines, they have their own class
-			print '<div class="diff_info">%s</div>' % escape(l)
-			continue
-
-		color = ""
-		if l[0] == '+':
-			color = 'style="color:#008800;"'
-		elif l[0] == '-':
-			color = 'style="color:#cc0000;"'
-		elif l[0] == '@':
-			color = 'style="color:#990099; '
-			color += 'border: solid #ffe0ff; '
-			color += 'border-width: 1px 0px 0px 0px; '
-			color += 'margin-top: 2px;"'
-		elif l.startswith('Files'):
-			# binary differences
-			color = 'style="color:#666;"'
-		print '<div class="pre" %s>' % color + escape(l) + '</div>'
+def print_diff(dsrc):
+    for l in dsrc:
+        # remove the trailing newline
+        if len(l) > 1:
+            l = l[:-1]
+
+        if l.startswith("diff"):
+            # file lines, they have their own class
+            print('<div class="diff_info">%s</div>' % xmlescape(l))
+            continue
+
+        color = ""
+        if l[0] == "+":
+            color = 'style="color:#008800;"'
+        elif l[0] == "-":
+            color = 'style="color:#cc0000;"'
+        elif l[0] == "@":
+            color = 'style="color:#990099; '
+            color += "border: solid #ffe0ff; "
+            color += "border-width: 1px 0px 0px 0px; "
+            color += 'margin-top: 2px;"'
+        elif l.startswith("Files"):
+            # binary differences
+            color = 'style="color:#666;"'
+        print('<div class="pre" %s>' % color + xmlescape(l) + "</div>")
 
 
 def print_darcs_diff(dsrc):
-	for l in dsrc:
-		l = fixu8(l)
-
-		if not l.startswith("    "):
-			# comments and normal stuff
-			print '<div class="pre">' + escape(l) + "</div>"
-			continue
-
-		l = l.strip()
-		if not l:
-			continue
-
-		if l[0] == '+':
-			cl = 'class="pre" style="color:#008800;"'
-		elif l[0] == '-':
-			cl = 'class="pre" style="color:#cc0000;"'
-		else:
-			cl = 'class="diff_info"'
-		print '<div %s>' % cl + escape(l) + '</div>'
-
-
-def print_shortlog(last = PATCHES_PER_PAGE, topi = 0, fname = None):
-	ps = get_last_patches(last, topi, fname)
-
-	if fname:
-		title = '<a class="title" href="%s;a=filehistory;f=%s">' % \
-				(config.myreponame, fname)
-		title += 'History for path %s' % escape(fname)
-		title += '</a>'
-	else:
-		title = '<a class="title" href="%s;a=shortlog">shortlog</a>' \
-				% config.myreponame
-
-	print '<div>%s</div>' % title
-	print '<table cellspacing="0">'
-
-	if topi != 0:
-		# put a link to the previous page
-		ntopi = topi - last
-		if ntopi < 0:
-			ntopi = 0
-		print '<tr><td>'
-		if fname:
-			print '<a href="%s;a=filehistory;topi=%d;f=%s">...</a>' \
-				% (config.myreponame, ntopi, fname)
-		else:
-			print '<a href="%s;a=shortlog;topi=%d">...</a>' \
-				% (config.myreponame, ntopi)
-		print '</td></tr>'
-
-	alt = True
-	for p in ps:
-		if p.name.startswith("TAG "):
-			print '<tr class="tag">'
-		elif alt:
-			print '<tr class="dark">'
-		else:
-			print '<tr class="light">'
-		alt = not alt
+    for l in dsrc:
+        if not l.startswith("    "):
+            # comments and normal stuff
+            print('<div class="pre">' + xmlescape(l) + "</div>")
+            continue
+
+        l = l.strip()
+        if not l:
+            continue
+
+        if l[0] == "+":
+            cl = 'class="pre" style="color:#008800;"'
+        elif l[0] == "-":
+            cl = 'class="pre" style="color:#cc0000;"'
+        else:
+            cl = 'class="diff_info"'
+        print("<div %s>" % cl + xmlescape(l) + "</div>")
+
+
+def print_shortlog(last=PATCHES_PER_PAGE, topi=0, fname=None):
+    ps = get_last_patches(last, topi, fname)
+
+    if fname:
+        title = '<a class="title" href="%s;a=filehistory;f=%s">' % (
+            config.myreponame,
+            fname,
+        )
+        title += "History for path %s" % xmlescape(fname)
+        title += "</a>"
+    else:
+        title = (
+            '<a class="title" href="%s;a=shortlog">shortlog</a>'
+            % config.myreponame
+        )
+
+    print("<div>%s</div>" % title)
+    print('<table cellspacing="0">')
+
+    if topi != 0:
+        # put a link to the previous page
+        ntopi = topi - last
+        if ntopi < 0:
+            ntopi = 0
+        print("<tr><td>")
+        if fname:
+            print(
+                '<a href="%s;a=filehistory;topi=%d;f=%s">...</a>'
+                % (config.myreponame, ntopi, fname)
+            )
+        else:
+            print(
+                '<a href="%s;a=shortlog;topi=%d">...</a>'
+                % (config.myreponame, ntopi)
+            )
+        print("</td></tr>")
+
+    alt = True
+    for p in ps:
+        if p.name.startswith("TAG "):
+            print('<tr class="tag">')
+        elif alt:
+            print('<tr class="dark">')
+        else:
+            print('<tr class="light">')
+        alt = not alt
 
-		print """
+        print(
+            """
   <td><i>%(age)s</i></td>
   <td>%(author)s</td>
   <td>
